####################################################################################
####################################################################################
#                                                                                  #
#   same sign ditop using Pythia by zhichao.                                       #
#                                                                                  #
####################################################################################
####################################################################################

from AthenaCommon.AlgSequence import AlgSequence 
topAlg = AlgSequence("TopAlg") 

include ( "MC10JobOptions/MC10_Pythia_Common.py" )

####################################################################################

Pythia.PythiaCommand += [
	"pysubs msel 0",
# IMSS(1)=1 : general MSSM simulation (model parameters set by array RMSS) :
	"pymssm imss 1 11",
        "pydat3 mdcy 15 1 0" # Turn off tau decays
                       ]

#####################################################################################
# SUBPROCESS SELECTION :                                                            #
#####################################################################################
Pythia.PythiaCommand += [
# activate subprocess 121 : g + g -> g~ + g~ and f + f -> g~ + g~
     "pysubs msub 243 1",
     "pysubs msub 244 1",
     ]
#####################################################################################
# SWITCH OFF ALL DECAY CHANNELS 210 -> 288 :                                        #
#####################################################################################
Pythia.PythiaCommand += [ 
#open g~-> t + ~t1* channel
         "pydat3 mdme 1997 1 1",    
#close the others
#                         ]
#Pythia.PythiaCommand += [
#open g~-> tbar + ~t1 channel
         "pydat3 mdme 1996 1 1",
         "pydat3 mdme 1975 1 0",
         "pydat3 mdme 1976 1 0",
         "pydat3 mdme 1977 1 0",
         "pydat3 mdme 1978 1 0",
         "pydat3 mdme 1979 1 0",
         "pydat3 mdme 1980 1 0",
         "pydat3 mdme 1981 1 0",
         "pydat3 mdme 1982 1 0",
         "pydat3 mdme 1983 1 0",
         "pydat3 mdme 1984 1 0",
         "pydat3 mdme 1985 1 0",
         "pydat3 mdme 1986 1 0",
         "pydat3 mdme 1987 1 0",
         "pydat3 mdme 1988 1 0",
         "pydat3 mdme 1989 1 0",
         "pydat3 mdme 1990 1 0",
         "pydat3 mdme 1991 1 0",
         "pydat3 mdme 1992 1 0",
         "pydat3 mdme 1993 1 0",
         "pydat3 mdme 1994 1 0",
         "pydat3 mdme 1995 1 0",
         "pydat3 mdme 1998 1 0",
         "pydat3 mdme 1999 1 0",
         "pydat3 mdme 2000 1 0",
         "pydat3 mdme 2001 1 0",
         "pydat3 mdme 2002 1 0",
         "pydat3 mdme 2003 1 0",
         "pydat3 mdme 2004 1 0",
         "pydat3 mdme 2005 1 0",
         "pydat3 mdme 2006 1 0",
         "pydat3 mdme 2007 1 0",
         "pydat3 mdme 2008 1 0",
         "pydat3 mdme 2009 1 0",
         "pydat3 mdme 2010 1 0",
         "pydat3 mdme 2011 1 0",
         "pydat3 mdme 2012 1 0",
         "pydat3 mdme 2013 1 0",
         "pydat3 mdme 2014 1 0",
         "pydat3 mdme 2015 1 0",
         "pydat3 mdme 2016 1 0",
         "pydat3 mdme 2017 1 0",
         "pydat3 mdme 2018 1 0",
         "pydat3 mdme 2019 1 0",
         "pydat3 mdme 2020 1 0",
         "pydat3 mdme 2021 1 0",
         "pydat3 mdme 2022 1 0",
         "pydat3 mdme 2023 1 0",
         "pydat3 mdme 2024 1 0",
         "pydat3 mdme 2025 1 0",
         "pydat3 mdme 2026 1 0",
         "pydat3 mdme 2027 1 0",
         "pydat3 mdme 2028 1 0",
         "pydat3 mdme 2029 1 0",
         "pydat3 mdme 2030 1 0",
         "pydat3 mdme 2031 1 0",
         "pydat3 mdme 2032 1 0",
         "pydat3 mdme 2033 1 0",
         "pydat3 mdme 2034 1 0",
         "pydat3 mdme 2035 1 0",
         "pydat3 mdme 2036 1 0",
         "pydat3 mdme 2037 1 0",
         "pydat3 mdme 2038 1 0",
         "pydat3 mdme 2039 1 0",
         "pydat3 mdme 2040 1 0",
         "pydat3 mdme 2041 1 0",
         "pydat3 mdme 2042 1 0",
         "pydat3 mdme 2043 1 0",
         "pydat3 mdme 2044 1 0",
         "pydat3 mdme 2045 1 0",
         "pydat3 mdme 2046 1 0",
         "pydat3 mdme 2047 1 0",
         "pydat3 mdme 2048 1 0",
         "pydat3 mdme 2049 1 0",
         "pydat3 mdme 2050 1 0",
         "pydat3 mdme 2051 1 0",
         "pydat3 mdme 2052 1 0",
         "pydat3 mdme 2053 1 0",
         "pydat3 mdme 2054 1 0",
         "pydat3 mdme 2055 1 0",
         "pydat3 mdme 2056 1 0",
         "pydat3 mdme 2057 1 0",
         "pydat3 mdme 2058 1 0",
         "pydat3 mdme 2059 1 0",
         "pydat3 mdme 2060 1 0",
         "pydat3 mdme 2061 1 0",
         "pydat3 mdme 2062 1 0",
         "pydat3 mdme 2063 1 0",
         "pydat3 mdme 2064 1 0",
         "pydat3 mdme 2065 1 0",
         "pydat3 mdme 2066 1 0",
         "pydat3 mdme 2067 1 0",
         "pydat3 mdme 2068 1 0",
         "pydat3 mdme 2069 1 0",
         "pydat3 mdme 2070 1 0",
         "pydat3 mdme 2071 1 0",
         "pydat3 mdme 2072 1 0",
         "pydat3 mdme 2073 1 0",
         "pydat3 mdme 2074 1 0",
         "pydat3 mdme 2075 1 0",
         "pydat3 mdme 2076 1 0",
         "pydat3 mdme 2077 1 0",
         "pydat3 mdme 2078 1 0",
         "pydat3 mdme 2079 1 0",
         "pydat3 mdme 2080 1 0",
         "pydat3 mdme 2081 1 0",
         "pydat3 mdme 2082 1 0",
         "pydat3 mdme 2083 1 0",
         "pydat3 mdme 2084 1 0",
         "pydat3 mdme 2085 1 0",
         "pydat3 mdme 2086 1 0",
         "pydat3 mdme 2087 1 0",
         "pydat3 mdme 2088 1 0",
         "pydat3 mdme 2089 1 0",
         "pydat3 mdme 2090 1 0",
         "pydat3 mdme 2091 1 0",
         "pydat3 mdme 2092 1 0",
         "pydat3 mdme 2093 1 0",
         "pydat3 mdme 2094 1 0",
         "pydat3 mdme 2095 1 0",
         "pydat3 mdme 2096 1 0",
         "pydat3 mdme 2097 1 0",
         "pydat3 mdme 2098 1 0",
         "pydat3 mdme 2099 1 0",
         "pydat3 mdme 2100 1 0",
         "pydat3 mdme 2101 1 0",
         "pydat3 mdme 2102 1 0",
         "pydat3 mdme 2103 1 0",
         "pydat3 mdme 2104 1 0",
         "pydat3 mdme 2105 1 0",
         "pydat3 mdme 2106 1 0",
         "pydat3 mdme 2107 1 0",
         "pydat3 mdme 2108 1 0",
         "pydat3 mdme 2109 1 0",
         "pydat3 mdme 2110 1 0",
         "pydat3 mdme 2111 1 0",
         "pydat3 mdme 2112 1 0",
         "pydat3 mdme 2113 1 0",
         "pydat3 mdme 2114 1 0",
         "pydat3 mdme 2115 1 0",
         "pydat3 mdme 2116 1 0",
         "pydat3 mdme 2117 1 0",
         "pydat3 mdme 2118 1 0",
         "pydat3 mdme 2119 1 0",
         "pydat3 mdme 2120 1 0",
         "pydat3 mdme 2121 1 0",
         "pydat3 mdme 2122 1 0",
         "pydat3 mdme 2123 1 0",
         "pydat3 mdme 2124 1 0",
         "pydat3 mdme 2125 1 0",
         "pydat3 mdme 2126 1 0",
         "pydat3 mdme 2127 1 0",
         "pydat3 mdme 2128 1 0",
         "pydat3 mdme 2129 1 0",
         "pydat3 mdme 2130 1 0",
         "pydat3 mdme 2131 1 0",
         "pydat3 mdme 2132 1 0",
         "pydat3 mdme 2133 1 0",
         "pydat3 mdme 2134 1 0",
         "pydat3 mdme 2135 1 0",
         "pydat3 mdme 2136 1 0",
         "pydat3 mdme 2137 1 0",
         "pydat3 mdme 2138 1 0",
         "pydat3 mdme 2139 1 0",
         "pydat3 mdme 2140 1 0",
         "pydat3 mdme 2141 1 0",
         "pydat3 mdme 2142 1 0",
         "pydat3 mdme 2143 1 0",
         "pydat3 mdme 2144 1 0",
         "pydat3 mdme 2145 1 0",
         "pydat3 mdme 2146 1 0",
         "pydat3 mdme 2147 1 0",
         "pydat3 mdme 2148 1 0",
         "pydat3 mdme 2149 1 0",
         "pydat3 mdme 2150 1 0",
         "pydat3 mdme 2151 1 0",
         "pydat3 mdme 2152 1 0",
         "pydat3 mdme 2153 1 0",
         "pydat3 mdme 2154 1 0",
         "pydat3 mdme 2155 1 0",
         "pydat3 mdme 2156 1 0",
         "pydat3 mdme 2157 1 0",
         "pydat3 mdme 2158 1 0",
         "pydat3 mdme 2159 1 0",
         "pydat3 mdme 2160 1 0",
         "pydat3 mdme 2161 1 0",
                                  ]


Pythia.PythiaCommand += [
#open t->W+ b , W+->e ve

         "pydat3 mdme 41 1 0",
         "pydat3 mdme 42 1 0",
         "pydat3 mdme 43 1 0",
         "pydat3 mdme 44 1 0",
         "pydat3 mdme 45 1 0",
         "pydat3 mdme 46 1 1",
         "pydat3 mdme 47 1 0",
         "pydat3 mdme 48 1 0",
         "pydat3 mdme 49 1 0",
         "pydat3 mdme 50 1 0",
         "pydat3 mdme 51 1 0",
         "pydat3 mdme 52 1 0",
         "pydat3 mdme 53 1 0",
         "pydat3 mdme 54 1 0",
         "pydat3 mdme 55 1 0",
                        ]

Pythia.PythiaCommand += [
## W decay mode setting
         "pydat3 mdme 190 1 0",
         "pydat3 mdme 191 1 0",
         "pydat3 mdme 192 1 0",
         "pydat3 mdme 194 1 0",
         "pydat3 mdme 195 1 0",
         "pydat3 mdme 196 1 0",
         "pydat3 mdme 198 1 0",
         "pydat3 mdme 199 1 0",
         "pydat3 mdme 200 1 0",
         "pydat3 mdme 206 1 1",
         "pydat3 mdme 207 1 1",
         "pydat3 mdme 208 1 0",
                          ]

Pythia.PythiaCommand += [
## ~t1_bar -> c + ~chi0 and ~t1_bar -> b + ~chi1-
         "pydat3 mdme 1775 1 0",
## chi1- + b
         "pydat3 mdme 1776 1 1",
         "pydat3 mdme 1777 1 0",
         "pydat3 mdme 1778 1 0",
         "pydat3 mdme 1779 1 0",
         "pydat3 mdme 1780 1 0",
         "pydat3 mdme 1781 1 0",
         "pydat3 mdme 1782 1 0",
         "pydat3 mdme 1783 1 0",
         "pydat3 mdme 1784 1 0",
         "pydat3 mdme 1785 1 0",
         "pydat3 mdme 1786 1 0",
#chi0 c
         "pydat3 mdme 1787 1 1",
         "pydat3 mdme 1788 1 0",
         "pydat3 mdme 1789 1 0",
         "pydat3 mdme 1790 1 0",
         "pydat3 mdme 1791 1 0",
         "pydat3 mdme 1792 1 0",
         "pydat3 mdme 1793 1 0",
         "pydat3 mdme 1794 1 0",
         "pydat3 mdme 1795 1 0",
         "pydat3 mdme 1796 1 0",
         "pydat3 mdme 1797 1 0",
         "pydat3 mdme 1798 1 0",
         "pydat3 mdme 1799 1 0",
         "pydat3 mdme 1800 1 0",
         "pydat3 mdme 1801 1 0",
# ~chi1- -> chi_10 + W-
         "pydat3 mdme 2595 1 0",
         "pydat3 mdme 2596 1 0",
         "pydat3 mdme 2597 1 1",
         "pydat3 mdme 2598 1 0",
         "pydat3 mdme 2599 1 0",
         "pydat3 mdme 2600 1 0",
         "pydat3 mdme 2601 1 0",
         "pydat3 mdme 2602 1 0",
         "pydat3 mdme 2603 1 0",
         "pydat3 mdme 2604 1 0",
         "pydat3 mdme 2605 1 0",
         "pydat3 mdme 2606 1 0",
         "pydat3 mdme 2607 1 0",
         "pydat3 mdme 2608 1 0",
         "pydat3 mdme 2609 1 0",
         "pydat3 mdme 2610 1 0",
         "pydat3 mdme 2611 1 0",
         "pydat3 mdme 2612 1 0",
         "pydat3 mdme 2613 1 0",
         "pydat3 mdme 2614 1 0",
         "pydat3 mdme 2615 1 0",
         "pydat3 mdme 2616 1 0",
         "pydat3 mdme 2617 1 0",
         "pydat3 mdme 2618 1 0",
         "pydat3 mdme 2619 1 0",
         "pydat3 mdme 2620 1 0",
         "pydat3 mdme 2621 1 0",
         "pydat3 mdme 2622 1 0",
         "pydat3 mdme 2623 1 0",
         "pydat3 mdme 2624 1 0",
         "pydat3 mdme 2625 1 0",
         "pydat3 mdme 2626 1 0",
         "pydat3 mdme 2627 1 0",
         "pydat3 mdme 2628 1 0",
         "pydat3 mdme 2629 1 0",
         "pydat3 mdme 2630 1 0",
         "pydat3 mdme 2631 1 0",
         "pydat3 mdme 2632 1 0",
         "pydat3 mdme 2633 1 0",
         "pydat3 mdme 2634 1 0",
         "pydat3 mdme 2635 1 0",
         "pydat3 mdme 2636 1 0",
         "pydat3 mdme 2637 1 0",
         "pydat3 mdme 2638 1 0",
         "pydat3 mdme 2639 1 0",
         "pydat3 mdme 2640 1 0",
         "pydat3 mdme 2641 1 0",
         "pydat3 mdme 2642 1 0",
         "pydat3 mdme 2643 1 0",
         "pydat3 mdme 2644 1 0",
         "pydat3 mdme 2645 1 0",
         "pydat3 mdme 2646 1 0",
         "pydat3 mdme 2647 1 0",
         "pydat3 mdme 2648 1 0",
         "pydat3 mdme 2649 1 0",
         "pydat3 mdme 2650 1 0",
         "pydat3 mdme 2651 1 0",
         "pydat3 mdme 2652 1 0",
         "pydat3 mdme 2653 1 0",
         "pydat3 mdme 2654 1 0",
         "pydat3 mdme 2655 1 0",
         "pydat3 mdme 2656 1 0",
         "pydat3 mdme 2657 1 0",
         "pydat3 mdme 2658 1 0",
         "pydat3 mdme 2659 1 0",
         "pydat3 mdme 2660 1 0",
         "pydat3 mdme 2661 1 0",
         "pydat3 mdme 2662 1 0",
         "pydat3 mdme 2663 1 0",
         "pydat3 mdme 2664 1 0",
         "pydat3 mdme 2665 1 0",
         "pydat3 mdme 2666 1 0",
         "pydat3 mdme 2667 1 0",
         "pydat3 mdme 2668 1 0",
         "pydat3 mdme 2669 1 0",
         "pydat3 mdme 2670 1 0",
         "pydat3 mdme 2671 1 0",
         "pydat3 mdme 2672 1 0",
         "pydat3 mdme 2673 1 0",
         "pydat3 mdme 2674 1 0",
         "pydat3 mdme 2675 1 0",
         "pydat3 mdme 2676 1 0",
         "pydat3 mdme 2677 1 0",
         "pydat3 mdme 2678 1 0",
         "pydat3 mdme 2679 1 0",
         "pydat3 mdme 2680 1 0",
         "pydat3 mdme 2681 1 0",
         "pydat3 mdme 2682 1 0",
         "pydat3 mdme 2683 1 0",
         "pydat3 mdme 2684 1 0",
         "pydat3 mdme 2685 1 0",
         "pydat3 mdme 2686 1 0",
         "pydat3 mdme 2687 1 0",
         "pydat3 mdme 2688 1 0",
         "pydat3 mdme 2689 1 0",
         "pydat3 mdme 2690 1 0",
         "pydat3 mdme 2691 1 0",
         "pydat3 mdme 2692 1 0",
         "pydat3 mdme 2693 1 0",
         "pydat3 mdme 2694 1 0",
         "pydat3 mdme 2695 1 0",
         "pydat3 mdme 2696 1 0",
         "pydat3 mdme 2697 1 0",
         "pydat3 mdme 2698 1 0",
         "pydat3 mdme 2699 1 0",
         "pydat3 mdme 2700 1 0",
         "pydat3 mdme 2701 1 0",
         "pydat3 mdme 2702 1 0",
         "pydat3 mdme 2703 1 0",
         "pydat3 mdme 2704 1 0",
         "pydat3 mdme 2705 1 0",
         "pydat3 mdme 2706 1 0",
         "pydat3 mdme 2707 1 0",
         "pydat3 mdme 2708 1 0",
         "pydat3 mdme 2709 1 0",
         "pydat3 mdme 2710 1 0",
         "pydat3 mdme 2711 1 0",
         "pydat3 mdme 2712 1 0",
         "pydat3 mdme 2713 1 0",
         "pydat3 mdme 2714 1 0",
         "pydat3 mdme 2715 1 0",
         "pydat3 mdme 2716 1 0",
         "pydat3 mdme 2717 1 0",
         "pydat3 mdme 2718 1 0",
         "pydat3 mdme 2719 1 0",
         "pydat3 mdme 2720 1 0",
         "pydat3 mdme 2721 1 0",
         "pydat3 mdme 2722 1 0",
         "pydat3 mdme 2723 1 0",
         "pydat3 mdme 2724 1 0",
         "pydat3 mdme 2725 1 0",
         "pydat3 mdme 2726 1 0",
         "pydat3 mdme 2727 1 0",
         "pydat3 mdme 2728 1 0",
         "pydat3 mdme 2729 1 0",
         "pydat3 mdme 2730 1 0",
         "pydat3 mdme 2731 1 0",
         "pydat3 mdme 2732 1 0",
         "pydat3 mdme 2733 1 0",
         "pydat3 mdme 2734 1 0",
         "pydat3 mdme 2735 1 0",
         "pydat3 mdme 2736 1 0",
         "pydat3 mdme 2737 1 0",
         "pydat3 mdme 2738 1 0",
         "pydat3 mdme 2739 1 0",
         "pydat3 mdme 2740 1 0",
         "pydat3 mdme 2741 1 0",
         "pydat3 mdme 2742 1 0",
         "pydat3 mdme 2743 1 0",
         "pydat3 mdme 2744 1 0",
         "pydat3 mdme 2745 1 0",
         "pydat3 mdme 2746 1 0",
         "pydat3 mdme 2747 1 0",
         "pydat3 mdme 2748 1 0",
         "pydat3 mdme 2749 1 0",
         "pydat3 mdme 2750 1 0",
         "pydat3 mdme 2751 1 0",
         "pydat3 mdme 2752 1 0",
         "pydat3 mdme 2753 1 0",
         "pydat3 mdme 2754 1 0",
         "pydat3 mdme 2755 1 0",
         "pydat3 mdme 2756 1 0",
         "pydat3 mdme 2757 1 0",
         "pydat3 mdme 2758 1 0",
         "pydat3 mdme 2759 1 0",
         "pydat3 mdme 2760 1 0",
         "pydat3 mdme 2761 1 0",
         "pydat3 mdme 2762 1 0",
         "pydat3 mdme 2763 1 0",
         "pydat3 mdme 2764 1 0",
         "pydat3 mdme 2765 1 0",
         "pydat3 mdme 2766 1 0",
         "pydat3 mdme 2767 1 0",
         "pydat3 mdme 2768 1 0",
         "pydat3 mdme 2769 1 0",
         "pydat3 mdme 2770 1 0",
         "pydat3 mdme 2771 1 0",
         "pydat3 mdme 2772 1 0",
         "pydat3 mdme 2773 1 0",
         "pydat3 mdme 2774 1 0",
         "pydat3 mdme 2775 1 0",
         "pydat3 mdme 2776 1 0",
         "pydat3 mdme 2777 1 0",
         "pydat3 mdme 2778 1 0",
         "pydat3 mdme 2779 1 0",
         "pydat3 mdme 2780 1 0",
         "pydat3 mdme 2781 1 0",
         "pydat3 mdme 2782 1 0",
         "pydat3 mdme 2783 1 0",
         "pydat3 mdme 2784 1 0",
         "pydat3 mdme 2785 1 0",
         "pydat3 mdme 2786 1 0",
         "pydat3 mdme 2787 1 0",
         "pydat3 mdme 2788 1 0",
         "pydat3 mdme 2789 1 0",
         "pydat3 mdme 2790 1 0",
         "pydat3 mdme 2791 1 0",
         "pydat3 mdme 2792 1 0",
         "pydat3 mdme 2793 1 0",
         "pydat3 mdme 2794 1 0",
         "pydat3 mdme 2795 1 0",
         "pydat3 mdme 2796 1 0",
         "pydat3 mdme 2797 1 0",
         "pydat3 mdme 2798 1 0",
         "pydat3 mdme 2799 1 0",
         "pydat3 mdme 2800 1 0",
         "pydat3 mdme 2801 1 0",
         "pydat3 mdme 2802 1 0",
         "pydat3 mdme 2803 1 0",
         "pydat3 mdme 2804 1 0",
         "pydat3 mdme 2805 1 0",
         "pydat3 mdme 2806 1 0",
         "pydat3 mdme 2807 1 0",
         "pydat3 mdme 2808 1 0",
         "pydat3 mdme 2809 1 0",
         "pydat3 mdme 2810 1 0",
         "pydat3 mdme 2811 1 0",
         "pydat3 mdme 2812 1 0",
         "pydat3 mdme 2813 1 0",
         "pydat3 mdme 2814 1 0",
         "pydat3 mdme 2815 1 0",
         "pydat3 mdme 2816 1 0",
         "pydat3 mdme 2817 1 0",
         "pydat3 mdme 2818 1 0",
         "pydat3 mdme 2819 1 0",
         "pydat3 mdme 2820 1 0",
         "pydat3 mdme 2821 1 0",
         "pydat3 mdme 2822 1 0",
         "pydat3 mdme 2823 1 0",
         "pydat3 mdme 2824 1 0",
         "pydat3 mdme 2825 1 0"
         ]

#####################################################################################
# PYTHIA CONTROL OUTPUT SETTING :                                                   #
#####################################################################################
Pythia.PythiaCommand += [
# here added to print out the set parameters
	"pyinit pylisti 13"]

Pythia.SusyInputFile = "susy_comp550.txt" #SLHA input file

#####################################################################################
# INCLUDES :                                                                        #
#####################################################################################
# ... Tauola 
include ( "MC10JobOptions/MC10_Tauola_Fragment.py" )  
# ... Photos 
include ( "MC10JobOptions/MC10_Photos_Fragment.py" ) 

#####################################################################################
# FILTERS :                                                                         #
#####################################################################################
# Multilepton Filter providing the lepton-lepton final state,
# to be compatible to the BG CSC.006353.AcerMC_Zbb_tautau.py 
from GeneratorFilters.GeneratorFiltersConf import MultiLeptonFilter
topAlg += MultiLeptonFilter()

MultiLeptonFilter = topAlg.MultiLeptonFilter
MultiLeptonFilter.Ptcut = 5000.
MultiLeptonFilter.Etacut = 2.7
MultiLeptonFilter.NLeptons = 2

try:
     StreamEVGEN.RequireAlgs = [ "MultiLeptonFilter" ] 
except Exception, e:
     pass

#####################################################################################
# FILTER EFFICIENCY :                                                               #
#####################################################################################
from MC10JobOptions.PythiaEvgenConfig import evgenConfig
evgenConfig.efficiency = 0.8

# SUSYEvgenConfig
from MC10JobOptions.SUSYEvgenConfig import evgenConfig
